import {
    createRouter,
    createWebHistory
} from "vue-router"
import HomeView from "../views/HomeView.vue"

const router = createRouter({
    history: createWebHistory(
        import.meta.env.BASE_URL),
    routes: [{
            path: "/",
            name: "home",
            component: HomeView
        },
        {
            path: "/item/:id",
            name: "item",
            // lazy-loaded when the route is visited
            component: () => import("../views/ItemView.vue"),
            props: true
        },
        {
            path: "/item",
            redirect: "/"
        },
        {
            path: "/ping",
            name: "Ping",
            component: () => import("../views/PingView.vue")
        },
    ]
})

export default router